#include <iostream>
#include "bassasio.h"

#pragma comment(lib, "bassasio.lib")

void ErrorMes(char* sMes, int Res)
{
  std::cout << "\n" << std::cout << sMes << Res << "\n\n";
  system("pause");
  exit(EXIT_FAILURE);   // EXIT_SUCCESS, EXIT_FAILURE
}

void TestAsio(void) 
{
  std::cout << "\n--------------     ------------\n";
  int nSamplesPerSec[] = {44100, 48000, 64000, 88200, 96000, 176400, 192000};
  if(FALSE == BASS_ASIO_Init(0, BASS_ASIO_THREAD)) 
    ErrorMes("    ( )  BASS_ASIO_Init. : ", BASS_ASIO_ErrorGetCode());
  if(FALSE == BASS_ASIO_SetDevice(0))
    ErrorMes("     BASS_ASIO_SetDevice. : ", BASS_ASIO_ErrorGetCode());
	if(FALSE == BASS_ASIO_ChannelReset(TRUE,-1,BASS_ASIO_RESET_ENABLE))
    ErrorMes("      BASS_ASIO_ChannelReset. : ", BASS_ASIO_ErrorGetCode());
  if(FALSE == BASS_ASIO_ChannelReset(TRUE,-1,BASS_ASIO_RESET_RATE))
    ErrorMes("       BASS_ASIO_ChannelReset c BASS_ASIO_RESET_RATE. : ", BASS_ASIO_ErrorGetCode());
  for(int i = 0; i < sizeof(nSamplesPerSec)/sizeof(nSamplesPerSec[0]); i++)
  {
    if(FALSE == BASS_ASIO_SetRate((double) nSamplesPerSec[i]))
    {
      std::cout << "\n!!!      " << nSamplesPerSec[i] << std::endl << std::endl;
      continue;
    }
    std::cout << "\n+++++++++++++++   : " << BASS_ASIO_GetRate() << " +++++++++++++++\n\n";
    system("pause");
  }
  BASS_ASIO_Free();
}

int main(int argc, char* argv[]) 
{
  setlocale(LC_ALL, "");
  TestAsio();
  system("pause");
}